// Josephus problem with Rank Tree

object Josephus3 {
  def josephus(n: Int, m: Int): String = {
    val A = new Array[String](n)
    for (i <- 0 until n)
      A(i) = (i+1).toString
    val R = new RankTree[String](A)
    var p = 0
    for (i <- 1 until n) {
      if (n < 30)
	println(R + " " + R.find(p))
      else if (n < 300)
	print(R.find(p) + " ")
      p = (p + m) % R.size
      R.remove(p)
      if (p == R.size)
	p = 0
    }
    R.find(p)
  }

  def main(args: Array[String]) {
    val result = josephus(args(0).toInt, args(1).toInt)
    println("The last one is " + result)
  }
}

